
module Pod
    class PodTarget

        def contain_vendored_libraries_and_no_vendored_frameworks?
            return @uses_libraries_no_frameworks if defined? @uses_libraries_no_frameworks
            @uses_libraries_no_frameworks = begin
                accessors = file_accessors.reject { |a| a.spec.test_specification? }
                !accessors.empty? && accessors.all?{ |a| a.vendored_frameworks.blank? } && accessors.any?{ |a| not a.vendored_libraries.blank? }
            end
        end

        def should_generate_module_map_for_a_pod_should_not_build?
            @should_generate_module_map_for_a_pod_should_not_build ||= begin
                self.defines_module? && contain_vendored_libraries_and_no_vendored_frameworks?
            end
        end

    end
end




module Pod
    class Target
        # @since 1.5.0
        # checked 1.6 1.7 1.8
        # except `requires_frameworks?` is renamed to `build_as_framework?`, but is have an alias.
        class BuildSettings

            class PodTargetSettings

                # Patch (because there is a should_build? check)
                #
                FIX_MODULE_OLD_module_map_file_to_import = instance_method(:module_map_file_to_import)
                define_method(:module_map_file_to_import) do

                    if (not target.should_build?) && target.should_generate_module_map_for_a_pod_should_not_build?
                        # ---- Code bellow is copied form the original method ----
                        #
                        # ---------------- this line is deleted ------------------
                        # return unless target.should_build?
                        # -------------------------------------------------------
                        #
                        return if target.requires_frameworks?
                        return unless target.defines_module?

                        if target.uses_swift?
                            # for swift, we have a custom build phase that copies in the module map, appending the .Swift module
                            "${PODS_CONFIGURATION_BUILD_DIR}/#{target.label}/#{target.product_module_name}.modulemap"
                        else
                            "${PODS_ROOT}/#{target.module_map_path.relative_path_from(target.sandbox.root)}"
                        end
                        # ---- Code above is copied form the original method ----
                    else
                        # call original
                        FIX_MODULE_OLD_module_map_file_to_import.bind(self).()
                    end

                end # patch ended

            end

        end
    end
end
